import java.awt.*;

/**
 * Added for task 3
 */
public class BorderShape extends Shape {

    private int line;
    private Color color;
    private Shape shape;

    public BorderShape(Shape shape, int lineThickness, final int gap, Color color) {

        super( shape.getX()-gap-lineThickness,
                shape.getY()-gap-lineThickness,
                shape.getWidth() + 2 * (lineThickness + gap),
                shape.getHeight() + 2 * (lineThickness + gap),
                shape.getMotion() );

        this.line = lineThickness;
        this.color = color;
        this.shape = shape;

        shape.setMotion(new Motion() {

            public Point getNextPosition(Shape shape, int x, int y, int width, int height, Point p) {
                return new Point(
                        BorderShape.this.x + gap + line, BorderShape.this.y + gap + line);
            }

            public void addBounceListener(BounceListener listener)
            {
            }

            public void removeBounceListener(BounceListener listener)
            {
            }
        });

    }

    public void move(int x, int y, int width, int height) {
        super.move(x,y,width,height);
        shape.move(x,y,width,height);
    }

    public void paint(Painter painter) {

        Color c = painter.getColor();
        painter.setColor(color);

        for (int i = 0; i < line; i++) {
            painter.drawRect(getX()+i,getY()+i,getWidth()-(2*i)-1,getHeight()-(2*i)-1);
        }
        painter.setColor(c);
        shape.paint(painter);
    }
}
