import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

public class Bounce extends JPanel implements ActionListener {
    private final int DELAY = 20;

    private Animator animator = new Animator();

    private Timer timer = new Timer(DELAY, this);

    public Bounce() {
        animator.add(new RectangleShape(10, 10, 40, 25, new BouncingMotion(5, 7)));

        Image image = Toolkit.getDefaultToolkit().createImage("FelisMargarita.jpg");  // ADDED for task 1
        ImageIcon imageIcon = new ImageIcon(image);
        ImageShape shape = new ImageShape(20,51,new GravityMotion(3,4, 1),imageIcon);   // ADDED for task 1

        BorderShape shape2 = new BorderShape(shape,2,0,Color.blue);

        animator.add(new BorderShape(shape2,3,3,Color.red)); // ADDED for task 3
        animator.add(new TextShape("Hello", new RectangleShape(30,30,100, 30, new BouncingMotion(4,5)))); // ADDED for task 2

        ChangingShape cs = new ChangingShape(
                new RectangleShape(0, 0, 25, 35, new BouncingMotion(2, 3)),
                new OvalShape(0, 0, new BouncingMotion(2, 3))
        );

        animator.add(cs);

        timer.start();
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        int width = getSize().width - 1;
        int height = getSize().height - 1;
        animator.clock(width, height, new GraphicsPainter(g));
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame("Bounce");
        frame.setContentPane(new Bounce());
        frame.setSize(500, 500);
        frame.setVisible(true);
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    }

    public void actionPerformed(ActionEvent e) {
        repaint();
    }
}
