import java.awt.*;
import java.util.ArrayList;

/**
 * Added for Task 4
 */
public class BouncingMotion implements Motion  {

    int deltaX;
    int deltaY;
    java.util.List<BounceListener> listeners = new ArrayList<BounceListener>();

    public BouncingMotion(int deltaX, int deltaY) {
        this.deltaX = deltaX;
        this.deltaY = deltaY;
    }

    public Point getNextPosition(Shape shape, int x, int y, int width, int height, Point p) {

        int nextX = p.x + this.deltaX;
        int nextY = p.y + this.deltaY;

        if (nextX <= x) {
            nextX = x;
            this.deltaX = -this.deltaX;
            fireBounceOccurred(); // added for Task 5
        } else if (nextX + shape.getWidth() >= (width+x)) {  // changed WIDTH -> this.width; changed width -> width+x
            nextX = width + x - shape.getWidth();  // changed WIDTH -> this.width; changed width -> width + x
            this.deltaX = -this.deltaX;
            fireBounceOccurred(); // added for Task 5
        }

        if (nextY <= y) {
            nextY = y;
            this.deltaY = -this.deltaY;
            fireBounceOccurred(); // added for Task 5
        } else if (nextY + shape.getHeight() >= (height+y)) {  // changed HEIGHT -> this.height; changed height -> height + y
            nextY = height + y - shape.getHeight();  // changed HEIGHT -> this.height; changed height -> height + y
            this.deltaY = -this.deltaY;
            fireBounceOccurred(); // added for Task 5
        }
        return new Point(nextX, nextY);
    }

    void fireBounceOccurred() {
        for (BounceListener listener : listeners) {
            listener.bounceOccurred();
        }
    }

    public void addBounceListener(BounceListener listener) // added for Task 5
    {
        listeners.add(listener);
    }

    public void removeBounceListener(BounceListener listener) // added for Task 5
    {
        listeners.remove(listener);
    }
}
