/**
 * Added for Task 5
 */
public class ChangingShape extends Shape implements BounceListener {

    Shape a, b;
    boolean showingA = true;

    public ChangingShape(Shape a, Shape b) {

        super(a.x, a.y, a.getMotion());
        this.a = a;
        this.b = b;

        if (a.getWidth() != b.getWidth() || a.getHeight() != b.getHeight()) {
            throw new RuntimeException("The two shapes must be same size");
        }

        getMotion().addBounceListener(this);
    }

    public void move(int x, int y, int width, int height) {
        super.move(x, y, width, height);
        a.x = this.x;
        a.y = this.y;
        b.x = a.x;
        b.y = a.y;
    }

    public void paint(Painter painter) {
        if (showingA) a.paint(painter);
        else b.paint(painter);
    }

    public void bounceOccurred() {
        showingA = !showingA;
    }
}
