import java.awt.*;

public class GraphicsPainter implements Painter {
    private Graphics g;

    public GraphicsPainter(Graphics g) {
        this.g = g;
    }

    public void append(String s) {
        g.drawString(s, 10, 10);
    }

    public void drawRect(int x, int y, int width, int height) {
        g.drawRect(x, y, width, height);
    }

    public void drawOval(int x, int y, int width, int height) {
        g.drawOval(x, y, width, height);
    }

    // Added for Task 1
    public void drawImage(int x, int y, Image image) {
        g.drawImage(image, x, y, null);
    }

    // Added for Task 2
    public void drawCenteredText(int x, int y, String text) {
        FontMetrics metrics = g.getFontMetrics();

        int x2 = x - (int)Math.round(metrics.stringWidth(text)/2.0);
        int y2 = y + (int)Math.round((metrics.getAscent() + metrics.getDescent()) / 2.0);
        y2 -= metrics.getDescent();

        g.drawString(text, x2, y2);
    }

    // Added for Task 4
    public Color getColor() {
        return g.getColor();
    }

    // Added for Task 4
    public void setColor(Color c) {
        g.setColor(c);
    }

}
