import java.awt.*;

/**
 * Added for Task 4.
 */
public class GravityMotion extends BouncingMotion {

    int g;

    public GravityMotion(int deltaX, int deltaY, int g) {
        super(deltaX, deltaY);
        this.g = g;
    }

    public Point getNextPosition(Shape shape, int x, int y, int width, int height, Point p) {
        int nextX = p.x + this.deltaX;
        int nextY = p.y + this.deltaY;


        if (nextX <= x) {
            nextX = x;
            this.deltaX = -this.deltaX;
            fireBounceOccurred(); // added for Task 5
        } else if (nextX + shape.getWidth() >= (width+x)) {  // changed WIDTH -> this.width; changed width -> width+x
            nextX = width + x - shape.getWidth();  // changed WIDTH -> this.width; changed width -> width + x
            this.deltaX = -this.deltaX;
            fireBounceOccurred(); // added for Task 5
        }

        if (nextY <= y) {
            nextY = y;
            this.deltaY = -this.deltaY;
            fireBounceOccurred(); // added for Task 5
        } else if (nextY + shape.getHeight() >= (height+y)) {  // changed HEIGHT -> this.height; changed height -> height + y
            nextY = height + y - shape.getHeight();  // changed HEIGHT -> this.height; changed height -> height + y
            this.deltaY = -this.deltaY;
            fireBounceOccurred(); // added for Task 5
        } else {
            deltaY += g;
        }


        // having this here will cause a dissapation of the bouncing
        //deltaY += g;

        return new Point(nextX, nextY);
    }
}
