import junit.framework.TestCase;

public class TestBouncing extends TestCase {
	private MockPainter painter;


	public void setUp() {
		painter = new MockPainter();
	}

	public void testShapeMoveWithBounceOffRight() {
		RectangleShape shape = new RectangleShape(100, 20, 25, 35, new BouncingMotion(12, 15)); // added 25, 35, for task 2
		shape.paint(painter);
		shape.move(0, 0, 135, 10000); // added 0, 0 for task 3
		shape.paint(painter);
		shape.move(0, 0, 135, 10000); // added 0, 0 for task 3
		shape.paint(painter);
		assertEquals("(rectangle 100,20,25,35)(rectangle 110,35,25,35)"
				+ "(rectangle 98,50,25,35)", painter.toString());
	}

	public void testShapeMoveWithBounceOffLeft() {
		RectangleShape shape = new RectangleShape(10, 20, 25, 35, new BouncingMotion(-12, 15)); // added 25, 35, for task 2
		shape.paint(painter);
		shape.move(0, 0, 10000, 10000); // added 0, 0 for task 3
		shape.paint(painter);
		shape.move(0, 0, 10000, 10000); // added 0, 0 for task 3
		shape.paint(painter);
		assertEquals("(rectangle 10,20,25,35)(rectangle 0,35,25,35)"
				+ "(rectangle 12,50,25,35)", painter.toString());
	}

	public void testShapeMoveWithBounceOffBottomAndRight() {
		RectangleShape shape = new RectangleShape(10, 90, 25, 35, new BouncingMotion(-12, 15)); // added 25, 35, for task 2
		shape.paint(painter);
		shape.move(0, 0, 125, 135); // added 0, 0 for task 3
		shape.paint(painter);
		shape.move(0, 0, 125, 135); // added 0, 0 for task 3
		shape.paint(painter);
		assertEquals("(rectangle 10,90,25,35)(rectangle 0,100,25,35)"
				+ "(rectangle 12,85,25,35)", painter.toString());
	}
}
