import junit.framework.TestCase;

/**
 * some tests adapted from ssom015
 */
public class TestChangingShape extends TestCase {

    private MockPainter painter;


    public void setUp() {
        painter = new MockPainter();
    }


    public void testChangingShapeWithoutLimits() {

            ChangingShape shape = new ChangingShape(new RectangleShape(100, 134,25, 35,new GravityMotion(10, 15,1)), new OvalShape(100, 134,25, 35,new GravityMotion(10, 20, 1)));

            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);

            assertEquals("(rectangle 100,134,25,35)"
                    + "(rectangle 110,149,25,35)"
                    + "(rectangle 120,165,25,35)"
                    + "(rectangle 130,182,25,35)"
                    + "(rectangle 140,200,25,35)",
                    painter.toString());
    }
    public void testChangingShapeBounceOffRight() {

            ChangingShape shape = new ChangingShape(new RectangleShape(100, 20, 25, 35, new GravityMotion(12, 15, 1)),new OvalShape(50, 20, 25, 35, new GravityMotion(12, 10, 1)));

            shape.paint(painter);
            shape.move(0, 0, 135, 10000);
            shape.paint(painter);
            shape.move(0, 0, 135, 10000);
            shape.paint(painter);
            shape.move(0, 0, 135, 10000);
            shape.paint(painter);
            shape.move(0, 0, 135, 10000);
            shape.paint(painter);

            assertEquals("(rectangle 100,20,25,35)"
                    + "(oval 110,35,25,35)"
                    + "(oval 98,51,25,35)"
                    + "(oval 86,68,25,35)"
                    + "(oval 74,86,25,35)",
                    painter.toString());
    }
    public void testChangingShapeBounceOffLeft() {

        ChangingShape shape = new ChangingShape((new RectangleShape(10, 20, 25, 35, new GravityMotion(-12, 15, 1))),new OvalShape(10, 20, 25, 35, new GravityMotion(-12, 15, 1)));

            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);

            assertEquals("(rectangle 10,20,25,35)"
                    + "(oval 0,35,25,35)"
                    + "(oval 12,51,25,35)"
                    + "(oval 24,68,25,35)"
                    + "(oval 36,86,25,35)",
                    painter.toString());
    }

    public void testChangingShapeBounceOffBottom() {

        ChangingShape shape = new ChangingShape(new RectangleShape(100, 134,25, 35, new GravityMotion(0, 15, 1)),new OvalShape(100, 120,25, 35, new GravityMotion(0, 15, 1)));

            shape.paint(painter);
            shape.move(0, 0, 135, 200);
            shape.paint(painter);
            shape.move(0, 0, 135, 200);
            shape.paint(painter);
            shape.move(0, 0, 135, 200);
            shape.paint(painter);
            shape.move(0, 0, 135, 200);
            shape.paint(painter);

            assertEquals("(rectangle 100,134,25,35)"
                    + "(rectangle 100,149,25,35)"
                    + "(oval 100,165,25,35)"
                    + "(oval 100,149,25,35)"
                    + "(oval 100,134,25,35)",
                    painter.toString());
        }

    public void testChangingShapeBounceOffTop() {

        ChangingShape shape = new ChangingShape(new RectangleShape(100, 10, 25, 35, new GravityMotion(12, -15, 1)),new OvalShape(100, 10, 25, 35, new GravityMotion(12, -15, 1)));

            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);
            shape.move(0, 0, 10000, 10000);
            shape.paint(painter);

            assertEquals("(rectangle 100,10,25,35)"
                    + "(oval 112,0,25,35)"
                    + "(oval 124,15,25,35)"
                    + "(oval 136,31,25,35)"
                    + "(oval 148,48,25,35)",
                    painter.toString());
    }

}
