import junit.framework.TestCase;

public class TestGravityMotion extends TestCase {
    private MockPainter painter;

    public void setUp() {
        painter = new MockPainter();
    }

    public void testGravityBounceOffBottom() {

        // rectangle shape with height 35, intial y position 134, velocity in y direction 15 and acceleration due to gravity 1
        RectangleShape shape = new RectangleShape(100, 134, 25, 35, new GravityMotion(0, 15, 1)); // added 25, 35, for task 2

        shape.paint(painter);
        shape.move(0, 0, 135, 200);
        shape.paint(painter);
        shape.move(0, 0, 135, 200);
        shape.paint(painter);
        shape.move(0, 0, 135, 200);
        shape.paint(painter);
        shape.move(0, 0, 135, 200);
        shape.paint(painter);

        assertEquals("(rectangle 100,134,25,35)"+
                "(rectangle 100,149,25,35)"+
                "(rectangle 100,165,25,35)"+
                "(rectangle 100,149,25,35)"+
                "(rectangle 100,134,25,35)",
                painter.toString());
    }

    /**
     * adapted from acoo079
     */
    public void testGravityBounceOffBottomWithHorizontalVelocity() {
        Shape shape = new RectangleShape(10, 14, 10, 10, new GravityMotion(2, 0, 1));
        shape.move(0, 0, 10000, 25);
        shape.paint(painter);
        shape.move(0, 0, 10000, 25);
        shape.paint(painter);
        shape.move(0, 0, 10000, 25);
        shape.paint(painter);

        assertEquals("(rectangle 12,14,10,10)"+
                "(rectangle 14,15,10,10)"+
                "(rectangle 16,14,10,10)",
                painter.toString());
    }

    /**
     * adapted from acoo079
     */
    public void testGravityBounceOffRoof() {
        Shape shape = new RectangleShape(10, 5, 10, 10, new GravityMotion(0, -2, -1));
        shape.move(0, 0, 10000, 1000);
        shape.paint(painter);
        shape.move(0, 0, 10000, 1000);
        shape.paint(painter);
        shape.move(0, 0, 10000, 1000);
        shape.paint(painter);
        shape.move(0, 0, 10000, 1000);
        shape.paint(painter);

        assertEquals("(rectangle 10,3,10,10)"+
                "(rectangle 10,0,10,10)"+
                "(rectangle 10,3,10,10)"+
                "(rectangle 10,5,10,10)",
                painter.toString());

    }
}
