import junit.framework.TestCase;

import javax.swing.*;

/**
 * some tests adapted from acoo079
 */
public class TestImageShape extends TestCase {

    private MockPainter painter;

    private BouncingMotion motion;
    private ImageIcon imageIcon;

    final int deltaX = 5;

    public void setUp() {
        imageIcon = new ImageIcon("FelisMargarita.jpg");
        painter = new MockPainter();
        motion  = new BouncingMotion(deltaX,0);
    }

    // checks that the size of the shape is the size of the image
    public void testImageSize() {

        ImageShape imageShape = new ImageShape(0,0, motion,imageIcon);
        assertEquals(imageShape.getWidth(), imageIcon.getImage().getWidth(null));
        assertEquals(imageShape.getHeight(), imageIcon.getImage().getHeight(null));
    }

    // checks that the image bounces properly
    public void testImageShapeBounce() {

        int imageWidth = imageIcon.getImage().getWidth(null);

        int x = 5;

        ImageShape imageShape = new ImageShape(x,x, motion,imageIcon);

        int worldWidth = x + imageWidth + deltaX;

        imageShape.move(0, 0, worldWidth, 100000);
        imageShape.paint(painter);
        imageShape.move(0, 0, worldWidth, 100000);
        imageShape.paint(painter);

        assertEquals("(image " + (x + deltaX) + "," + x+")(image " + x +"," + x + ")", painter.toString());
    }

}
