import junit.framework.TestCase;

public class TestTextShape extends TestCase {

    private MockPainter painter;

    public void setUp() {
        painter = new MockPainter();
    }

    /**
     * adapted from acoo079
     */
    public void testDrawTextShape() {
        int width = 10;
        int height = 8;
        int x = 10, y = 10;

        String text = "Hello World";

        Shape baseShape = new RectangleShape(x, y, width, height, new BouncingMotion(1,1));


        Shape textShape = new TextShape(text, baseShape);
        textShape.paint(painter);
        assertEquals(
            painter.toString(),
            "(rectangle " + x + "," + y + "," + width + "," + height + ")"+
            "(centeredText " + (x+width/2) + "," + (y+height/2) + "," + text + ")");
    }

}
